Index: /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs	(revision 17728)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs	(revision 17729)
@@ -55,4 +55,8 @@
     /// <returns>The new value.</returns>
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+    }
+
+    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       if (endValue <= 0 || startValue <= 0) throw new ArgumentException("startValue and endValue must be greater than 0.");
       double b = Math.Pow(endValue / startValue, 1.0 / (endIndex - startIndex));
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs	(revision 17728)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs	(revision 17729)
@@ -70,9 +70,13 @@
     /// <returns>The new value.</returns>
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      if (Base <= 0)
+      return Calculate(value, startValue, endValue, index, startIndex, endIndex, Base);
+    }
+
+    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex, double @base) {
+      if (@base <= 0)
         throw new ArgumentException("Base must be > 0.");
-      if (Base == 1.0)
-        return startValue + (endValue - startValue)*(index - startIndex)/(endIndex - startIndex);
-      return startValue + (endValue - startValue)*(Math.Pow(Base, 1.0*(index-startIndex)/(endIndex-startIndex)) - 1)/(Base - 1);
+      if (@base == 1.0)
+        return startValue + (endValue - startValue) * (index - startIndex) / (endIndex - startIndex);
+      return startValue + (endValue - startValue) * (Math.Pow(@base, 1.0 * (index - startIndex) / (endIndex - startIndex)) - 1) / (@base - 1);
     }
   }
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs	(revision 17728)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs	(revision 17729)
@@ -41,4 +41,8 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+    }
+
+    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double k = (endValue - startValue) / (endIndex - startIndex);
       double x = index - startIndex;
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs	(revision 17728)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs	(revision 17729)
@@ -41,4 +41,8 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+    }
+
+    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double a = (endValue - startValue) / ((endIndex - startIndex) * (endIndex - startIndex));
       return a * (index - startIndex) * (index - startIndex) + startValue;
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs	(revision 17728)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs	(revision 17729)
@@ -42,4 +42,8 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+    }
+
+    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double a = (endValue - startValue) / Math.Sqrt(endIndex - startIndex);
       return a * Math.Sqrt(index - startIndex) + startValue;