Index: /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs	(revision 17729)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/ExponentialDiscreteDoubleValueModifier.cs	(revision 17730)
@@ -43,4 +43,9 @@
     }
 
+    
+    protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Apply(value, startValue, endValue, index, startIndex, endIndex);
+    }
+
     /// <summary>
     /// Calculates a new value based on exponential decay or growth.
@@ -54,9 +59,5 @@
     /// <param name="endIndex">The end index.</param>
     /// <returns>The new value.</returns>
-    protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
-    }
-
-    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+    public static double Apply(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       if (endValue <= 0 || startValue <= 0) throw new ArgumentException("startValue and endValue must be greater than 0.");
       double b = Math.Pow(endValue / startValue, 1.0 / (endIndex - startIndex));
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs	(revision 17729)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/GeneralizedExponentialDiscreteDoubleValueModifier.cs	(revision 17730)
@@ -58,4 +58,8 @@
     }
 
+    protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+      return Apply(value, startValue, endValue, index, startIndex, endIndex, Base);
+    }
+
     /// <summary>
     /// Calculates a new value based on exponential decay or growth.
@@ -69,9 +73,5 @@
     /// <param name="endIndex">The final index.</param>
     /// <returns>The new value.</returns>
-    protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      return Calculate(value, startValue, endValue, index, startIndex, endIndex, Base);
-    }
-
-    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex, double @base) {
+    public static double Apply(double value, double startValue, double endValue, int index, int startIndex, int endIndex, double @base) {
       if (@base <= 0)
         throw new ArgumentException("Base must be > 0.");
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs	(revision 17729)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/LinearDiscreteDoubleValueModifier.cs	(revision 17730)
@@ -41,8 +41,18 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+      return Apply(value, startValue, endValue, index, startIndex, endIndex);
     }
 
-    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+    /// <summary>
+    /// Calculates a new value based on linear decay or growth.
+    /// </summary>
+    /// <param name="value">The previous value.</param>
+    /// <param name="startValue">The initial value.</param>
+    /// <param name="endValue">The final value.</param>
+    /// <param name="index">The current index.</param>
+    /// <param name="startIndex">The initial index.</param>
+    /// <param name="endIndex">The final index.</param>
+    /// <returns>The new value.</returns>
+    public static double Apply(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double k = (endValue - startValue) / (endIndex - startIndex);
       double x = index - startIndex;
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs	(revision 17729)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/QuadraticDiscreteDoubleValueModifier.cs	(revision 17730)
@@ -41,8 +41,18 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+      return Apply(value, startValue, endValue, index, startIndex, endIndex);
     }
 
-    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+    /// <summary>
+    /// Calculates a new value based on quadratic decay or growth.
+    /// </summary>
+    /// <param name="value">The previous value.</param>
+    /// <param name="startValue">The initial value.</param>
+    /// <param name="endValue">The final value.</param>
+    /// <param name="index">The current index.</param>
+    /// <param name="startIndex">The initial index.</param>
+    /// <param name="endIndex">The final index.</param>
+    /// <returns>The new value.</returns>
+    public static double Apply(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double a = (endValue - startValue) / ((endIndex - startIndex) * (endIndex - startIndex));
       return a * (index - startIndex) * (index - startIndex) + startValue;
Index: /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs
===================================================================
--- /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs	(revision 17729)
+++ /trunk/HeuristicLab.Optimization.Operators/3.3/SquareRootDiscreteDoubleValueModifier.cs	(revision 17730)
@@ -42,8 +42,18 @@
 
     protected override double Modify(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
-      return Calculate(value, startValue, endValue, index, startIndex, endIndex);
+      return Apply(value, startValue, endValue, index, startIndex, endIndex);
     }
 
-    public static double Calculate(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
+    /// <summary>
+    /// Calculates a new value based on sqrt decay or growth.
+    /// </summary>
+    /// <param name="value">The previous value.</param>
+    /// <param name="startValue">The initial value.</param>
+    /// <param name="endValue">The final value.</param>
+    /// <param name="index">The current index.</param>
+    /// <param name="startIndex">The initial index.</param>
+    /// <param name="endIndex">The final index.</param>
+    /// <returns>The new value.</returns>
+    public static double Apply(double value, double startValue, double endValue, int index, int startIndex, int endIndex) {
       double a = (endValue - startValue) / Math.Sqrt(endIndex - startIndex);
       return a * Math.Sqrt(index - startIndex) + startValue;